#!/usr/bin/luaweb
require("json")
require("lfs")
dofile("cgi.inc")
dofile("lua.inc")
chans = stdout2table("find /tmp/ -iname BChannelState-*")

function readFile(file)
    local f = io.open(file, "rb")
    local content = f:read("*all")
    f:close()
    return content
end
function detailInfo(info)
   	options = SplitCommandlineString(info)_, _, D, B = string.find(options["bchannel"],"(.-)/(.-)/")
    local ret={
		dchan=D,
        bchan=B,
        date=string.gsub(options["date"],':','\:'),
        called_party_number=string.gsub(options["called-party-number"], ':', '\:'),
        calling_party_number=string.gsub(options["calling-party-number"], ":", '\:'),
        csid=options["csid"],
        error=options["error"],
        type=options["type"],
        bps=options["bps"],
        ecm=options["ecm"],
        res=options["res"],
        t4=options["t4"],
        txp=options["txp"],
        rxp=options["rxp"]
    }	
	return ret
end




local results={}
local c=1
for i,b in pairs(chans)do
	found=os.execute("grep -q active "..b)
	if(found==0)then
		content=readFile(b)
		results[c]={}
		results[c]["file"]=b
		results[c]["details"]=detailInfo(content)
		results[c]["diffTime"]=os.difftime(os.time(),changeDate(b))
		c=c+1
	end
end

print ("Content-type: application/json\n")

printJs(results)


