#!/usr/bin/luaweb

dofile('../lua.inc')
dofile('../cgi.inc')
require('lfs')
require('json')

function string:split(sep)
    local sep, fields = sep or ":", {}
    local pattern = string.format("([^%s]+)", sep)
    self:gsub(pattern, function(c) fields[#fields+1] = c end)
    return fields
end

function listFax(path)
	local mytable={}
	entries = listFiles(path)

	

	if entries ~= nil then
		entries.n = nil
		table.sort(entries)
		local i=0;
		local c=0	


		while entries[i] ~= nil do
			entries[i]=(string.gsub(entries[i],path.."/",""))
	  	    if (string.find(entries[i], '.mail')~= nil) then
				c=c+1
				mytable[c]={}
			 
				year=string.sub(entries[i],1,4)	
				month=string.sub(entries[i],5,6)	--Function Month in lua.inc Number = Name
				day=string.sub(entries[i],7,8)
				hour=string.sub(entries[i],10,11)
				minute=string.sub(entries[i],12,13)
				second=string.sub(entries[i],14,15)
		 		data=string.gsub(entries[i],path.."/","")
				-- demoString 20120727-144651{OfficeMaster@Schulungsbox9}{benutzer9@schulung2010.ferrari-electronic.net}.mail
	  	    	if string.find(entries[i], '{')~= nil then
					name=string.split(entries[i], "{")
					--demo split result:
					--name[1]	= --20120727-144651
					--name[2]	= OfficeMaster@Schulungsbox9}
					--name[3]	= benutzer9@schulung2010.ferrari-electronic.net}.mail
					mytable[c]["sender"]=name[2]:gsub("}","")
					name[3]=name[3]:gsub("}","")
					mytable[c]["recipient"]=name[3]:gsub(".mail","")
				end
			

				mytable[c]["time"]=string.format("%s:%s:%s",hour,minute,second)	
				mytable[c]["link"]=data
				mytable[c]["pdfLink"]=data:gsub(".mail",".pdf")
				mytable[c]["date"]=string.format("%s-%s-%s",month,day,year)
		 		i=i+1
	      	else 
				i=i+1
	      	end
	   end
	end
	return mytable
end

faxTable={}
if(exists("/data/fax/good"))then
	faxTable["goodFax"]=listFax("/data/fax/good")
else
	 faxTable["goodFax"]={}
end
if(exists("/data/fax/bad"))then
	faxTable["badFax"]=listFax("/data/fax/bad")
else
	faxTable["badFax"]={}

end


print ("Content-type: application/json\n")
print(json.encode(faxTable))
