#!/usr/bin/luaweb
require("json")
dofile("cgi.inc")
dofile("lua.inc")
print ("Content-type: application/json\n")

jsRetval,jsData  = pcall(json.decode,getpost())
if(jsRetval ~= true)then
    print('{"err":"json error"}')
	os.exit(1)
end

local fax=jsData["fax"]
local action=jsData["action"]
local ftype=jsData["ftype"]
if(fax == nil or action == nil or ftype == nil)then
    print('{"err": "invalid post data"}')
	fax="20120803-150317{OfficeMaster@Schulungsbox9}{benutzer9@schulung2010.ferrari-electronic.net}.mail"
	action="send"
	ftype="good"
    os.exit(1)
end

local file="/data/fax/"..ftype.."/"..fax
function sendIt(fax)
    cmd=string.sub(fax,1,15)
    cmd='/usr/bin/omgfaxdeliver -q '..file
    resultTable["send"]=stdout2table(cmd.."; echo $?")
  	resultTable["sendRet"]=resultTable["send"][table.getn(resultTable["send"])]
--	table.remove(resultTable["send"],table.getn(resultTable["send"]))
end
function deleteIt(file)
    pdfFile=string.gsub(file,".mail",".pdf")
    dPDF=os.remove(pdfFile)
    dMail=os.remove(file)
    if(dPDF == true and dMail == true)then
        resultTable["delRet"]=0
        resultTable["del"]="files deleted"
    else
        resultTable["delRet"]=1
        resultTable["del"]="failed to delete files"
    end
end



resultTable={}
name=string.split(fax, "{")
name[3]=name[3]:gsub("}","")

resultTable["sender"]=name[2]:gsub("}","")
resultTable["recipient"]=name[3]:gsub(".mail","")
resultTable["file"]=file
resultTable["type"]=ftype
resultTable["send"]={}
resultTable["sendRet"]=""
resultTable["del"]={}
resultTable["delRet"]=""

year=string.sub(fax,1,4)
month=string.sub(fax,5,6)    --Function Month in lua.inc Number = Name
day=string.sub(fax,7,8)
hour=string.sub(fax,10,11)
minute=string.sub(fax,12,13)
second=string.sub(fax,14,15)

resultTable["date"]=month.."-"..day.."-"..year
resultTable["time"]=hour..":"..minute..":"..second





if(type(action) == "table")then
	resultTable["action"]={"send","delete"}
	sendIt(fax)
	if(resultTable["sendRet"] == "0")then
		deleteIt(file)
	else
		resultTable["delRet"]=1
		resultTable["del"]="Sending failed! - will not delete this file"
	end
end

if(type(action) == "string")then
	resultTable["action"]=action
	if(action == "send")then
		sendIt(fax)
	end
	if(action == "delete")then
		deleteIt(file)
	end
end



print(json.encode(resultTable))
