#!/usr/bin/luaweb
require("json")
require("lfs")
local omg = require("omg")
dofile("cgi.inc")
dofile("lua.inc")

--[[
files=stdout2table("ls /tmp/L2State-* 2>/dev/null | sort -V")

]]--
getChannels=stdout2table("/usr/bin/sudo /usr/bin/getchannels -m -d 2>&1 | sort -V | grep -v 'B-Channels'")
local pris=0
local fxs=0
local s0=0
local pcm=0
--print(getChannels)

function nameFromChannels(chan)
	for k,v in pairs(getChannels)do
		if(string.find(v,"^"..chan) ~= nil)then
			return(v)
		end
	end
	return ""
end


function getChannelName(dev)
	local chan=""
	chan=nameFromChannels(dev)
    if(string.find (chan, "S2M") ~= nil)then
        pris=pris+1
        return "PRI"..pris
    end
    if(string.find (chan, "FXS") ~= nil)then
        fxs=fxs+1
        return "Analog"..fxs
    end
    if(string.find (chan, "S0") ~= nil)then
        s0=s0+1
        return "BRI"..s0
    end
    pcm=pcm+1
    return "PCM"..pcm
end

function stdout2KVtable(cmd,delim)
    local myTable={}
    local i=1
    stdout=os.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
        line = string.gsub(line, '\'', '"')
        myTable[i]={}
        local c=1
        for str in string.gmatch(line, "([^%s]+)") do
            myTable[i][c]=str
            c=c+1
        end
        i=i+1
    end
    return myTable
end


local res={}
local l2table=os.capture("sudo getstates | sort")
res[1]={}
res[1]["hrx"]="L1"
res[1]["hsx"]="Calls"
res[1]["hax"]="Channel"
res[1]["hfx"]="L2"
i=2
for line in l2table:gmatch("[^\n\r]+")do
	res[i]={}
	Pairs=Split(line,", ")
	for a=1,table.getn(Pairs) do
		key=Split(Pairs[a],":")[1]
		val=Split(Pairs[a],":")[2]	
		res[i][key]=val
		if(key == "ILID")then
			--res[i]["name"]=getChannelName(val)
			res[i]["name"]=getChannelName(val)
		end
	end
	i=i+1
end


print ("Content-type: application/json\n")
printJs(res)
