#!/usr/bin/luaweb
require("json")
require("lfs")
dofile("lua.inc")
dofile("cgi.inc")

print ("Content-type: application/json\n")
--print ("Content-type: text/html\n")
local result={
	msg="",
	rc=false,
	wcount=0,		--count whiteSpace replaces
}
function write_file_numbers(filename, array)
  local tmpFile=os.captureN("/bin/mktemp")
  local f = assert(io.open(tmpFile, 'w'))
  for _,v in ipairs(array) do
    f:write(v, '\n')
  end
  f:close()
  os.execute("/usr/bin/sudo /bin/mv "..tmpFile.. " /data/numberlists/"..filename)
end

function writeList()
	post=getpost()
	data=json.decode(post)
	numTable={}


	--TODO: needs stricter checking for fileNames! don't trust the client!!!  ...the root/admin client?!
	if( data["file"] and data["list"] )then
		numbers=Split(data.list,"\n")
	end

	--printJs(table.getn(numbers))
	for i, num in ipairs(numbers) do
		if(string.find(num,"%s") ~= nil)then
			num=num:gsub("%s","")
			result.wcount=result.wcount+1
		end
		numTable[i]=num
	end
	
	result.msg="WARNING: "..tostring(result.wcount).." whitespace(s) removed!"
	
--	local envcmd=os.execute("/usr/bin/sudo /bin/mkdir -p /data/numberlists ; /usr/bin/sudo chown -R www-data:users /data/numberlists")
	local envcmd=os.execute("/usr/bin/sudo /bin/mkdir -p /data/numberlists")
	if(envcmd ~= 0)then
		result.msg="Could not store files on Server! Exitting"
		printJs(result)
		os.exit(1)
	end
	
	write_file_numbers(data.file,numTable)
	local check=os.execute("[ -e /data/numberlists/"..data.file.. " ]")
	if(check ~= 0)then
		result.msg="Could not store files on Server! Exitting"
		printJS(result)
		os.exit(1)
	end  --file exitst
	
	local converter_check=os.execute("test -e /usr/fb/bin/blwl")
	
	if(converter_check == 0 )then
		converter_cmd=os.execute("/usr/bin/sudo /usr/fb/bin/blwl c /data/numberlists/"..data.file.." /data/"..data.file)
	else
		result.msg="blwl not found! Firmware too old?"
		printJs(result)
		os.exit(1)
	end
	
	if(converter_cmd == 0)then
		result.rc=true
	
	else
		result.msg="Problems converting file! Aborting"	
	end

end

function changeDate(file)
    attr = lfs.attributes(file)
    if(attr == nil)then
        return(false)
    end
    assert (type(attr))
   return(attr.change)
end


if(request_param("readList") == "true" and request_param("listName") ~= nil )then
	local myList = stdout2table("/usr/fb/bin/blwl t /data/"..request_param("listName"))
	printJs(myList)
end

if(request_param("deleteList") == "true" and request_param("listName") ~= nil )then
	os.execute("/usr/bin/sudo /bin/rm /data/"..request_param("listName"))
end


if(request_param("writelist") == "true")then
	writeList()
	printJs(result)
end

if(request_param("getLists") == "true")then
	local ls=stdout2table("cd /data/ && ls *.lst 2>/dev/null")
	local returnTable={}
	for k,v in pairs(ls) do
		returnTable[k]={}
		returnTable[k]["name"]=v
		returnTable[k]["date"]=changeDate("/data/"..v)
	end
	printJs(returnTable)
end

if(request_param("num") ~= nil and request_param("list") ~= nil)then
local list=request_param("list")
local num=request_param("num")

local ret=os.captureN("/usr/fb/bin/blwl f /data/"..list.." "..num)


if(ret ~=nil)then
	result.rc=Split(ret,"=")[2]
end


printJs(result)
end
