#!/usr/bin/luaweb
require("json")
dofile("lua.inc")
dofile("cgi.inc")

print ("Content-type: application/json\n")

local ret={}
local killret={}

function proc2text(proc)
	local text=""	
    if(string.find(proc,"rtp.prc"))then
		return "rtp"
	elseif (string.find(proc,"sms.prc")) then
		return "sms"
	elseif (string.find(proc,"fax.prc")) then
		return "fax"
	elseif (string.find(proc,"interconnect.prc")) then
		return "interconnect"
	elseif (string.find(proc,"voice.prc")) then
		return "voice"
	elseif (string.find(proc,"faxt38.prc")) then
		return "faxt38"
	end
	return text
end


function parseRTPCMD(line)
	local tab={}
	local calling,called,interface
	local sepd=Split(line,"%s+")
	tab["pid"]=sepd[1]
	tab["elapsed"]=sepd[2]
	tab["type"]=proc2text(sepd[3])
	for k,v in pairs(sepd) do
		if(string.find(v,"-%-interface="))then
			interface=Split(v,"=")[2]
		end
		if(string.find(v,"-%-calledPartyNumber="))then
			called=Split(v,"=")[2]
		end
		if(string.find(v,"-%-called%-party%-number="))then
			called=Split(v,"=")[2]
		end
	
		if(string.find(v,"-%-callingPartyNumber="))then
			calling=Split(v,"=")[2]
		end
		if(string.find(v,"-%-calling%-party%-number="))then
			calling=Split(v,"=")[2]
		end
	end
	tab["interface"]=interface
	tab["calledPartyNumber"]=called
	tab["callingPartyNumber"]=calling
	return tab
end



function parsePsList(psTable)
	for i,line in pairs(psTable)do
		ret[i]=parseRTPCMD(line)
	end

end

function callKiller(pid, called, calling, interface, signal)
	for i,proc in pairs(ret)do
		if( (proc.pid == pid) and (proc.callingPartyNumber == calling) and (proc.calledPartyNumber == called) and (string.find(proc.interface, interface)) )then
			if(os.execute("ps fax |  awk -F \" \" '{print $1}' | grep "..pid)==0)then
				killret["ret"]=os.execute("/usr/bin/sudo /bin/kill -s "..signal.." "..pid)
			else
				killret["kill"]=false	--outdated pid?
				killret["ret"]="No such PID"
			end
		else
			killret["kill"]=false	--outdated pid?
			killret["ret"]="Parameters don't match any running PID!"
		end
	end
end

if(request_param("action") == "recordKill") then
	local pid=request_param("pid")
	local fName = request_param("fName")
	local reckill=stdout2table("LC_ALL=C /bin/ps o pid,cmd p " ..pid.." | grep -v 'PID CMD'")
	local kill={}
	kill.msg=""
	if(fName == nil or pid == nil)then
		kill.rc=1
		kill.msg="missing params!"
	end
	if(table.getn(reckill) ~= 1)then
		kill.rc=1
		kill.msg="Could not find PID! already dead? - please refresh list!"
	end
	if(kill.rc ~= 1)then
		local RE=string.gsub(reckill[1],"-%-","")	--lame: make them comparable
		local FName=string.gsub(fName,"-%-","")
		--print(RE)
		--print(FName)
		if(string.find(RE,FName,1,true) ~= nil)then
			--pid found and chan and calling and called and filename match! LEtz kill!
			kill.rc=os.execute("/usr/bin/sudo /bin/kill -s 9 "..pid)
		end
	end
	
	printJs(kill)
	os.exit(0)
end

function startRecord(chan,fName)
	local dirCmd=os.captureN("/usr/bin/sudo mkdir -p /data/recordings && /usr/bin/sudo chown -R www-data:users /data/recordings; echo $?")
	if(dirCmd ~= "0")then
		rres.rc=dirCmd
		rres.err="could not create folder"
		return false
	end
	rres.pid=os.captureN("./recChan.sh "..chan.." "..fName)
	rres.pidCheck=os.captureN("/bin/ps -axp "..rres.pid.." | grep readec | grep -q "..fName.." ; echo $?" )
	
end
function listactiveRecordings()
	local list=stdout2table("LC_ALL=C /bin/ps awxo pid,cmd | grep '/usr/bin/readec' | grep -v 'grep /usr/bin/readec'" )
	local ret={}
	for i,l in pairs(list)do
		lS = Split(l,"%s+")
--		printJs(lS)
		if(table.getn(lS) == 5)then
			ret[i]={}
			ret[i].recordPid=lS[1]
			ret[i].finterface=lS[4]
			local cmd=Split(string.gsub(lS[5],"/data/recordings/",""),"-%-")
		--	printJs(cmd)
			ret[i].prcPid=cmd[5]
			ret[i].calling=cmd[2]
			ret[i].called=cmd[3]
			ret[i].chan=cmd[4]			--chan from FileName ist escaped
		end
	end
	printJs(ret)
--	printJs(list)
end



function recordList()
	require("lfs")
    local ls=stdout2table("cd /data/recordings && ls *.wav")
    local recordings={}
    for i,rec in pairs(ls)do
        local recS=Split(rec,"-%-")
        if(table.getn(recS) == 6)then
            recordings[i]={}
            recordings[i].date=recS[1]
            recordings[i].calling=recS[2]
            recordings[i].called=recS[3]
            recordings[i].chan=recS[4]
            recordings[i].pid=recS[5]
        end
    end
  return(recordings)
end




if(arg[1] == "listActive" or request_param("action") == "listActive")then
	listactiveRecordings()
	os.exit(0)
end

if(request_param("action") == "listRecordings" or arg[1] == "debug")then
    local data = {}
    data.recordings = recordList()
    printJs(data)
end

if(request_param("action") == "record" or arg[1] == "debugRecording")then	
	rres={}	-- no local variable
	local calling=request_param("calling")
	local called=request_param("called")
	local chan=request_param("chan")
	local date=request_param("date")
    local pid=request_param("pid")

	
	if(calling == nil or called == nil or chan == nil or date == nil)then
		rres.res=1
		rres.err="missing params!"
	end
	local fName=date.."--"..calling.."--"..called.."--"..string.gsub(chan,"/","-").."--"..pid.."--"..".wav"
	rres.fName=fName
	rres.recordingPid = pid
	startRecord(chan,fName)

	printJs(rres)
end



local psList=stdout2table("LC_ALL=C ps awwxo  pid,etime,cmd | egrep '(sms.prc|rtp.prc|fax.prc|interconnect.prc|voice.prc|faxt38.prc)' | grep -v '(sms.prc|rtp.prc|fax.prc|interconnect.prc|voice.prc|faxt38.prc)' | sed  's/^[ \t]*//'")

if(table.getn(psList) ~= 0)then
	parsePsList(psList)
end




if(request_param("action") == nil)then	
	ret[table.getn(ret)+1]={}
	ret[table.getn(ret)]["date"]=os.captureN("date")

	printJs(ret)
end




if(request_param("action") == "kill") then
	local pid=request_param("pid")
	local calling = request_param("callingPartyNumber")
	local called = request_param("calledPartyNumber")
	local interface = request_param("finterface")
	local signal = request_param("signal")

	callKiller(pid, called, calling, interface, signal)
	printJs(killret)
end

if(arg[1] == "kill")then
	callKiller("5599", "+4972313894833", "+493328455938", "1.b/B13/S2M/2xG704IDT_E1",1)
	printJs(killret)
end

