#!/usr/bin/luaweb

require("json")
dofile("cgi.inc")
dofile("lua.inc")


local host=request_param("host")
local proto=request_param("proto")
local port=request_param("port")
local action=request_param("action")
local mode="web"
local result={}

if(host == nil or proto == nil or port == nil)then
	mode="cmd"
	host = arg[1]
	port = arg[2]
	proto = arg[3]
end


if(proto == "TCP" or proto == "tcp")then
	result["port"]=tcpProbe(host,port)
end
if(proto == "UDP" or proto == "udp")then
	result["port"]=udpProbe(host,port)
end

if(action == "all")then
	result["dnsResolv"]=dnsResolv(host)
end

result["host"]=host
result["requested_port"]=port
result["proto"]=proto


if(mode == "cmd")then
	print("STDOUT: "..host..proto..port)
end
if(mode == "web")then
	print ("Content-type: application/json\n")
	print(json.encode(result))
end
