#!/bin/bash

simple=$1
captureRunning=false
weblogRunning=false


[ ! -z $(pidof tcpdump) ] && captureRunning=true
[ ! -z $(pidof rsyslogd) ] && syslogRunning=true

[[ -e "/etc/rsyslog.d/51-weblog.conf" && "$syslogRunning" = true ]] && weblogRunning=true


if [ -z "$simple" ];then #standart
	echo { "weblog":$weblogRunning, "capture":$captureRunning  }
fi

if [ "$simple" = "simple" ];then
	if [[ $weblogRunning || $captureRunning ]];then
		echo "was running " > /tmp/bar
	fi
fi
