#!/bin/bash
action=$1
path="/usr/fb/html"
#path="/var/www"
#sudo="/usr/bin/sudo"
sudo=""

#if restart is specified action, just reset the log, but never "restart" the service
lsb_release -a | grep -q hardy && dist=hardy

echo -${dist}-

if [ "${dist}" == "" ];then dist="lucid";fi
if [ "${dist}" != "hardy" ]; then		###so we probably have a lucid here

	if [ "${action}" == "start" ];then
		[ ! -e /etc/rsyslog.d/51-weblog.conf ] && ${sudo} /bin/cp ${path}/cgi-bin/system/51-weblog.conf /etc/rsyslog.d/
		${sudo} initctl start rsyslog 2>&1 >/dev/null 2>&1
		[ $? == 1 ] &&  ${sudo} initctl restart rsyslog 2>&1 >/dev/null 2>&1
		[ $? == 1 ] &&  ${sudo} service rsyslog restart 2>&1 >/dev/null 2>&1
		echo "Rsyslog restartet by CGI-Script" | logger
	fi

	if [ "${action}" == "stop" ];then
		[ -e "/etc/rsyslog.d/51-weblog.conf" ] && /bin/rm /etc/rsyslog.d/51-weblog.conf
		${sudo} initctl restart rsyslog 2>&1 >/dev/null
	 	[ $? == 1 ] &&  ${sudo} service rsyslog restart 2>&1 >/dev/null 2>&1
		echo "Rsyslog restarted by CGI-Script" | logger
	fi

	if [ "${action}" == "reset" ];then
		${sudo} echo "log file content was reset by user" > /tmp/logs/syslog.olg
	fi

fi


if [ "${dist}" == "hardy" ]; then		###so we probably have a hardy here
	if [ "${action}" == "start" ];then
		echo "hardy action started"
		if [ -e /etc/syslog.conf ];then
			[ $(grep -q ^:msg,\ contains,\ \"PWD=\\/usr\\/fb\\/html\\/cgi-bin\".* /etc/syslog.conf; echo $?) -eq 1 ] && echo ':msg, contains, "PWD=/usr/fb/html/cgi-bin" ~' >> /etc/syslog.conf
			[ $(grep -q "^\*\.\*\ \\/tmp\\/logs\\/syslog.olg" /etc/syslog.conf; echo $?) -eq 1 ] && echo '*.* /tmp/logs/syslog.olg' >> /etc/syslog.conf
		fi
		if [ ! -e /etc/syslog.conf ];then 
	 		echo ':msg, contains, "PWD=/usr/fb/html/cgi-bin" ~' >> /etc/syslog.conf
		 	echo '*.* /tmp/logs/syslog.olg' >> /etc/syslog.conf
		fi
		 /etc/init.d/sysklogd restart 2>&1 >/dev/null
	fi

	if [ "${action}" == "stop" ];then	#remove syslog lines
		if [ -e /etc/syslog.conf ];then
			[ $(grep -q ^:msg,\ contains,\ \"PWD=\\/usr\\/fb\\/html\\/cgi-bin\".* /etc/syslog.conf; echo $?) -eq 0 ] && sed -i s/^:msg,\ contains,\ \"PWD=\\/usr\\/fb\\/html\\/cgi-bin\".*\//g /etc/syslog.conf 
			[ $(grep -q "^\*\.\*\ \\/tmp\\/logs\\/syslog.olg" /etc/syslog.conf; echo $?) -eq 0 ] && sed -i s/^\*\.\*\ \\/tmp\\/logs\\/syslog.olg//g /etc/syslog.conf 
		fi
		 /etc/init.d/sysklogd restart 2>&1 >/dev/null

	fi	
	if [ "${action}" == "reset" ];then
		${sudo} echo "log file content was reset by user" > /tmp/logs/syslog.olg
	fi


fi

chmod -R a+r /tmp/logs
echo -n "error:$?"
