#!/bin/bash

action=$1
t=$2
OS=$(omgsysteminfo --filter="os.name" --val)


if [ "$action" == "reset" ];then
	echo "log file content was reset by user" > /tmp/logs/syslog.olg
	echo "" > /tmp/logs/capture.cap
	exit 0
fi

if [ "$action" == "start" ];then
	echo ":msg, contains, \"PWD=/usr/fb/html/cgi-bin\" ~
*.* /tmp/logs/syslog.olg" > /etc/rsyslog.d/51-weblog.conf
	echo "log file content was reset by user" > /tmp/logs/syslog.olg
	echo "" > /tmp/logs/capture.cap
	./reconfigureWeblog.sh &
	
	timeout=$((t*60))
	sleep $timeout && rm -f /etc/rsyslog.d/51-weblog.conf && ./reconfigureWeblog.sh &
fi

if [ "$action" == "stop" ];then
	rm -f /etc/rsyslog.d/51-weblog.conf; ./reconfigureWeblog.sh &
fi





