#!/bin/bash

#create 1 filesystem image
#	1. for logging rsyslog		 	--> 100MB



# check if logs folder is already there
if [ ! -e /tmp/logs ]; then
	mkdir -p /tmp/logs/
fi


# check if filesystem image is already there:
if [ ! -e /data/tmplog.img ];then
	dd if=/dev/zero of=/data/tmplog.img bs=1024k count=100
	echo y | LC_ALL=C mkfs.ext3 /data/tmplog.img
fi

if [ ! $(mountpoint -q /tmp/logs/; echo $?) == 0 ]; then
	mount -o loop /data/tmplog.img /tmp/logs/
fi

rm -rf /tmp/logs/*
touch /tmp/logs/syslog

chown syslog:adm /tmp/logs/syslog
