#!/bin/bash
#$1 type [isdn]
#$2 protocol

#$3 host_and_port to call
#$4 calledPartyNumber
#$5 callingPartyNumber
#sample: 
#./$0 idsn udp 10.2.2.51:5060 0021 0301337

rm /tmp/testCalls2.log
exec 2>&1>/tmp/testCalls2.log
#echo $@ > /tmp/test
type=$1
protocol=$2
calledHost="$3"
calledPartyNumber="$4"
callingPartyNumber="$5"
#type=isdn
#calledHost=10.2.2.151:5060
#calledPartyNumber=0021


#local settings:
iface=$(LC_ALL=C /sbin/route -n | grep ^0.0.0.0  | grep UG | awk -F " " '{print $8}')
localAddress=$(C_ALL=C ifconfig eth0 | grep "inet addr:" | cut -d ":" -f 2 | cut -d " " -f 1)
port="6061"




#execute the command:
if [ "${protocol}" == "udp" ];then
	proto="u1"
fi
if [ "${protocol}" == "tcp" ];then
	proto="t1"
fi

echo "sipp ${calledHost} -sf /usr/fb/tests/sipp_xml/options.xml -mp 7500 -silent -t ${proto} -i ${localAddress} -mi ${localAddress}  -trace_dtmf -trace_msg -trace_shortmsg -trace_logs -trace_err -pause_msg_ign -m 1 -users 1 -s ${calledPartyNumber}  -rtp_receive -rtp_echo -set callingPartyNumber ${callingPartyNumber}" > /tmp/testSSS
echo " "
ulimit -n 1023
#script -q -c  "sudo sipp ${calledHost} -sf /usr/fb/tests/sipp_xml/options.xml -mp 7500 -silent -t ${proto} -i ${localAddress} -mi ${localAddress}  -trace_dtmf -trace_msg -trace_shortmsg -trace_logs -trace_err -pause_msg_ign -m 1 -users 1 -s ${calledPartyNumber}  -rtp_receive -rtp_echo -set callingPartyNumber ${callingPartyNumber}" 
sipp ${calledHost} -sf /usr/fb/tests/sipp_xml/options.xml -mp 7500 -silent -t ${proto} -i ${localAddress} -mi ${localAddress}  -trace_dtmf -trace_msg -trace_shortmsg -trace_logs -trace_err -pause_msg_ign -m 1 -users 1 -s ${calledPartyNumber}  -set callingPartyNumber ${callingPartyNumber}
sed -i  s/\'/\"/g /tmp/testCalls2.log

#removed: -rtp_receive -rtp_echo 
