function buildConnectionPage(tableHead,tableData,tableRowIds,targetDiv,errorString){
	$.ajax({
		url: "/cgi-bin/webData2.lua",
		processData:true,
		data:{ command: "connectionTable", option:"full"},
		dataType: "json",
		success: function(data) {
		
			sorted=data.connections;				// do some sorting later on
			var searched={}
			
			if(sorted["end"]==""){
				delete sorted["end"]
			}
			
			//calledPartyNumbers.push(data["called_party_number"]);
			
			
			//filter active/stopped
			var actives = { }   // store all active connections in here
			
			$.each(sorted,function(i,data){
				if(data["called_party_number"].indexOf(":")=="-1"){
					callData.calledPartyNumbers.push(data["called_party_number"]);
				}
				if(data["called_party_number"].indexOf(":") != "-1"){
					callData.hostsAndPorts.push(data["called_party_number"]);
				}
			
				if(!errorString && errorString != "all"){
					if(data["error"]=="active" || data["error"] == "none"){			//if error=active
						actives[i]=sorted[i];				//add this Object to "actives"
						delete sorted[i];					//remove it from data
					}
				}else{
					if(data["error"]==errorString){			//if error=active
						actives[i]=sorted[i];				//add this Object to "actives"
						delete sorted[i];					//remove it from data
					}
				}
				if(errorString == "all"){
					actives[i]=sorted[i];				//add this Object to "actives"
				}
				
				
				
			});
			
			//this setups autocomplete on TestCall tab
			//$("#localISDNTestcalledPartyNumber").autocomplete(callData.calledPartyNumbers);
			//$("#hostsAndPorts").autocomplete(callData.hostsAndPorts);
			
			if(!targetDiv){
				buildTable(tableHead,tableData,tableRowIds,actives,".activeConnections");  //build table with active
			}else{
			//	console.log("appendfirn to  " + targetDiv)
				
				buildTable(tableHead,tableData,tableRowIds,actives,targetDiv);  //build table with active
			}
			
			
			//buildTable(tableHead,tableData,tableRowIds,sorted,".allConnections");  // build table with others
			
			
			//$(".allConnections").clone().appendTo(".cloneConnections");
			
			//$('.cloneConnections').find("div.row.").css("opacity","1");

			}, error: function(x,y,z) { 
				alert("err loading connectionTable from webData2.lua \n\n\n" +  +x.responseText+"\n"+z +"\n\n"+ x.status  +"\n\n\n"+ x.responseText + x.responseText+"\n"+z);
		}
	});
}

function searchTable (tableHead, tableData, tableRowIds, searchString, searchField) {
	$.ajax({
		url: "/cgi-bin/webData2.lua",
		processData: true,
		data:{ command: "connectionTable", option: "full" },
		dataType: "json",
		success: function (data) {
			
    		
			if ( sorted["end"] == "" ){
				delete sorted["end"]
			}
			
			sorted=data.connections;
	        searched={};
	
			$.each(sorted,function(i,data){
				
				if(data[searchField]){
					if(searchField=="bchan"){
						if(data[searchField]==searchString){			//if error=active
							searched[i]=sorted[i];											//add thi
					}
				}
				else{ 
					if (data[searchField].indexOf(searchString) !=- 1) {			//if error=active
						searched[i]=sorted[i];											//add this Object to "searched"
					}
				}
					
				}
			});
			
			buildTable(tableHead,tableData,tableRowIds,searched,".searchConnections")  // build table with results
		}
	});
}




function partialUp(dchan,bchan,replaceElement){
	$.ajax({
		url: "/cgi-bin/webData2.lua",
		processData:true,
		data:{ 
			command: "connectionTable", 
			option: "partial",
			bchan: bchan, 
			dchan: dchan
			},
		dataType: "json",
		success: function(json) {
			localTableData=["dchan","bchan","date","called_party_number","calling_party_number","csid","error","type","bps","ecm","res","t4","txp","rxp"]; //need to be n json.data
			localTableRowIds={dchan:"dchan",bchan:"bchan"};
			localNewRow=getTableRows(tableData,tableRowIds,json);
			
			//data=json.connections;
			data=json.connections;
			if(data["end"]==""){
				delete data["end"]
			}
			
			localNewRow=getTableRows(localTableData,localTableRowIds,data);
			chan=dchan.replace(".","_")+bchan;
			//alert($('#connectionTable .row[chan='+chan+']').children());
			//$('.connections .row.'+chan).replaceWith(($(localNewRow).children()))
			
			$('.connections .row.'+chan).die();
			
			($(localNewRow).children()).replaceAll($('.connections .row.'+chan));
			
			
		}
	});
}


function onUpdate(dchan,bchan){
		chan=dchan.replace(".","_")+bchan;
		$('.connections .row.' + chan).replaceWith(' \
		 <div class="row '+chan+'" dchan="' + dchan + '" bchan="' + bchan + '"> \
		 	<div class="cell dchan"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell bchan"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell date"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell called"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell calling"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell csid"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	<div class="cell"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
		 	</div>\
		 ');
}




function updateRow(bchan,dchan){
	myChan=dchan.replace("-",".")
	$.ajax({
		url: "/cgi-bin/webData2.lua",
		processData:true,
		data:{  command: "connectionTable", 
				option: "partial",
				bchan:bchan, 
				dchan: myChan},
		dataType: "json",
		success: function(data) {
			
			var sorted=data.connectionTable.connections;
			$.each(sorted,function(i,data){
				chan=dchan+bchan;
					rowAction(i,data,"replaceWith",chan);
				
			});
		},
	
	error: function(x,y,z) {
		alert(x.responseText);
		alert(x.status);
        alert(x.responseText+"\n"+z);
	}
});
}


function getTableHead(tableHead,tableData){
	 htmlString="";
	 htmlString=htmlString+'<div class="row th">'
	 //alert(tableData.length);
	 for (var i = 0; i < tableHead.length; i++) {
		 htmlString=htmlString+'<div class="thcell '+tableData[i]+'">'+tableHead[i]+'</div>'
	 }
	 htmlString=htmlString+'</div>'
	 return(htmlString)
}


function getTableRows(tableData,tableRowIds,data){
	 
	 rows=document.createElement('div');
	 $.each(data,function(i,data){
		 
		 if(data.dchan){
			row=document.createElement('div');
		 	$(row).addClass("row").addClass("wrap")
		 		.attr("dchan",data.dchan)
		 		.attr("bchan",data.bchan)
		 		.addClass(data.dchan.replace(".","_")+data.bchan)
		 		.html('<div class="cell dchan">'+data.dchan+'</div> \
				   <div class="cell bchan">' + data.bchan + '</div>	\
		  		   <div class="cell date">' + data.date + '</div>	\
				   <div class="cell called">' + data.called_party_number + '</div> \
				   <div class="cell calling">' + data.calling_party_number + '</div> \
				   <div class="cell csid">' + data.csid +' &nbsp;</div> \
				   <div class="cell error ' + data.error +'">' + data.error + '</div> \
				   <div class="cell type">' + data.type + '&nbsp;</div> \
				   <div class="cell bps">' + data.bps + '&nbsp;</div> \
				   <div class="cell ecm">' + data.ecm + '&nbsp;</div> \
			  	   <div class="cell res">' + data.res+ '&nbsp;</div> \
				   <div class="cell t4">' + data.t4 + '&nbsp;</div> \
				   <div class="cell txp">' + data.txp + '</div> \
				   <div class="cell rxp">' + data.rxp + '</div>')
		 	$(rows).append(row);
		 }
	 });

	return(rows)
}

function buildTable(tableHead,tableData,tableRowIds,data,selector){
	
	//{"connections":[{"type":"type","csid":"13"}]}   -- data is only the array!:  [{"type":"type","csid":"13"}]  
	 table=document.createElement('div');
	 $(table).addClass("table");
	 $(table).append(getTableHead(tableHead,tableData));

	 var it = 1;var start = new Date().getTime();
		for (i = 0; i < it; ++i)  {
			tableRows=getTableRows(tableData,tableRowIds,data)
			$(table).append(tableRows);
		}
		var end = new Date().getTime();	if(it > 5)alert( end - start + "MS" );
	 
		
		$(selector).html(table);  
		if(($(table).find("div").length)>=16){
			$(selector+" .wrap").unwrap();
		}
}




function genericTableRows(tableData,tableRowIds,data){
	 htmlString="";
	 attributes="";
	$.each(data,function(i,data){
		htmlString=htmlString+'<div class="row" '+attributes+'>'
			htmlString=htmlString+'<div  class="cell td ">'+i+'</div>\n';
			htmlString=htmlString+'<div  class="cell td ">'+data+'</div>\n';
		htmlString=htmlString+'</div>'
				
	});
	 return (htmlString)
}