function commandProgression(command, target){
	$(target).html('<img src="images/ajax-loader.gif"/>')
	if(tid){
		alert("Command in progress!\nPlease Wait!")
		return false
	}
	$.ajax({
        url: "/cgi-bin/cmdMe.lua",
        data: { 
        	command:command,
        	action:"exec"
        },
        dataType: "json",
        success: function(data) {
        	$("div#nmap").append("writing to file: " +data.file)
        	if(data.error){
        		alert(data.error)
        		return false
        	}
        	if(!tid){
        		streamFile(data.file, data.pid, target);
        		tid = setInterval( function(){
        			streamFile(data.file, data.pid, target);
        		}, 1000);	
        	}
        }
     });
}

function streamFile(file, pid, target){
	$.ajax({
        url: "/cgi-bin/cmdMe.lua",
        data: { 
        	action:"read",
        	file:file,
        	pid:pid
        },
        dataType: "json",
        success: function(data) {
        	if(data.stdout.length){
        		$(target).html('<pre>'+data.stdout.join("<br/>") +'</pre>');
        	}
        	
        	if(data.pidAlive == 1 || data.error){
        		clearInterval(tid);
        		tid=undefined;
        		$(target).append('<div style="color:green">Command execution completed</div>')
        	}
        }
     });
} 

function traceHost2(host,target,loader){
        if(isTracing==true){alert("Trace in progress! please wait! "); return false}
        isTracing=true;
        $(target).empty()
        $(loader).show()
        $.ajax({
                async: true,
                url: "/cgi-bin/webData2.lua?command=trace&host="+host+"&rand="+numRand,
                dataType: "json",
                timeout: 4000000,
                success: function(data) {
                    if(data){
                        $(loader).hide();
                        
                        //$("#pingResult").empty();
                        $.each(data.command,function(i,item){
                            $(target).append('<pre class="stdout">' + item + '</pre>')
                        })
                    }else{
                    
                        alert("did not receive a valid response")
                    }
                    isTracing=false;
                },
                error: function(){
                    alert("Request timeouted or problems communicating with the server!")
                    isTracing=false;
                },
                complete:function(xhr,data){
                    //console.log(xhr)
                    //console.log(data)
                    isTracing=false;
                    
                }
            });
    }
     function pingHost2(host,target,loader){
        if(isPinging==true){alert("Ping check in progress, please wait!"); return false}
        isPinging=true;
        $(loader).show();
        $(target).empty();
        $.ajax({
                async: true,        //do it now, and wait
                url: "/cgi-bin/webData2.lua?command=ping&host="+host+"&rand="+numRand,
                dataType: "json",   
                success: function(data) {
                    if(data){
                        $(loader).hide()
                        $(target).empty();
                        $.each(data.command,function(i,item){
                           $(target).append('<pre class="stdout">' + item + '</pre>')
                        })
                    }else{
                        alert("did not receive a valid response")
                    }
                    isPinging=false;
                },
                timeout: function(){
                    alert("timeout occured! check your networking setup!")
                    isPinging=false;
                },
                error: function(){
                    alert("Error communicating with the server")
                    isPinging=false;
                },
                complete:function(){
                    isPinging=false;
                }
            });
    }
     function compareVersions (installed, required) {
    	 var i;
         var a = installed.split('.');
         var b = required.split('.');

         for (i = 0; i < a.length; ++i) {
             a[i] = Number(a[i]);
         }
         for (i = 0; i < b.length; ++i) {
             b[i] = Number(b[i]);
         }
         if (a.length == 2) {
             a[2] = 0;
         }

         if (a[0] > b[0]) return true;
         if (a[0] < b[0]) return false;

         if (a[1] > b[1]) return true;
         if (a[1] < b[1]) return false;

         if (a[2] > b[2]) return true;
         if (a[2] < b[2]) return false;

         return true;
     }
     

function refreshL2info(){
	    var $l2StateTable=$("div#l2StateTable");
	    $.ajax({
            url: "/cgi-bin/listL2states.lua?numrand="+ Math.floor(Math.random()*1101),
            processData:true,
            data: { json:"true" },
            dataType: "json",
            success: function(data) {
            	//data=data.sort(function(a,b){ if(a.ILID && b.ILID){  return a.name > b.name }} ).reverse();
            	data=data.sort(function(a,b){ if(a.ILID && b.ILID){  return a.ILID > b.ILID }} );
				var tmp = [];
				$.each(data,function(i,iface){	//filter for established (will be used in testCall's dropDowns)
					if(iface.L1 === "UP" && iface.L2 === "ESTABLISHED"){
						tmp.push(iface);
					}
				});
				pageData.isdnInterfaces = tmp;
				var kvTableData ={
                        table:data,
                        tableId: "l2states"
                };
             //   console.log(kvTableData.table)
                tmplOut=$.tmpl($("script#l2states-Template"),kvTableData);
                $l2StateTable.html(tmplOut);


                data=data.sort(function(a,b){ if(a.ILID && b.ILID){  return a.ILID > b.ILID }} );
                var xtmp=[];
                var port = 3217;
                $.each(data,function(i,v){
                	
                	if(v && v.ILID){
                		xtmp.push('<option value="'+port+'">'+v.ILID+'</option>')
                		port = port + 1;
                	}
	           	});

	            $("#dChannelSelect").html(xtmp.join(''))
            }
        });
    }
function doSystemTests(){
				numRand = Math.floor(Math.random()*1101);
				$.ajax({
					url: "/cgi-bin/runtests.lua",
					processData:true,
					data: {json:"true",rand:numRand},
					dataType: "json",
					success: function(data) {
					
						$("table#testOut tr.test").remove();

						element = $(document.createElement('div'));
                        if(data["end"] == "end"){   
                            element.append('<p>No Test definitions found, check your installation!</p>');
                        }else{
    						$.each(data,function(i, data){
    							delay=(i*1000);
    							$("table#testOut").append('<tr class="test '+data.result+'"> \
									<td id="name">'+data.name+'</td>\
									<td id="description">'+data.description+'</td>\
									<td id="state"><img src="/images/ajax-loader.gif" alt="loading"/></td>\
									<td id="result" class="result '+data.result+'">'+data.result+'</td>\
								</tr>');
    					 	});
						}
                        $("table#testOut tr.loading").remove();
                        $.each($("table#testOut tr.test"),function(i,item){
                        	$(this).hide().delay(i*1000).fadeIn("slow");
                        	$(this).children("td#state").html('<img src="/images/ajax-loader.gif" alt="loader"/>').hide().delay((i*1000)+500).fadeIn("slow");
                        	$(this).children("td#result").hide().delay((i*1000)+1000).fadeIn("slow");
                        	$(this).parent().find("td#state").find("img").show().delay(i*1000+1000).fadeOut("slow");
                        	
                        });
                        
                      },
        				 	error: function(x,y,z) {
							alert("	runtest got response:" + x.responseText + "\n" + z + "   status: " + x.status);
						}
				});
			}

$.fn.slideFadeToggle = function(easing, callback) {
    return this.animate({ opacity: 'toggle', height: 'toggle' }, "slow", easing, callback);
};
 /*function checkDNS(){
	numRand = Math.floor(Math.random()*1101);
    $nsTable=$("table#nameserverTable")
    $ns1=$nsTable.find("tr#ns1")
    $ns2=$nsTable.find("tr#ns2")
    $ns3=$nsTable.find("tr#loader")
    
    $("button#check_dns").attr('disabled', 'disabled');
    $ns1.hide()
    $ns2.hide()
    $ns3.show()
    $.ajax({
        async: true,
        url: "/cgi-bin/nsCheck.lua?numRand="+numRand,
        dataType: "json",
        timeout: 4000000,
        success: function(data) {
            $ns3.hide()
            if(data && data["ns1"]){
                $ns1.find("td.address").text(data["ns1"].address)
                $ns1.find("td.status").text(data["ns1"].status)
                $ns1.find("td.valid").text(data["ns1"]["valid"])
                if(data["ns1"]["valid"] != "true"){
                     $ns1.css("color","red")
                }
            }
              if(data && data["ns2"]){
                $ns2.find("td.address").text(data["ns2"].address)
                $ns2.find("td.status").text(data["ns2"].status)
                $ns2.find("td.valid").text(data["ns2"]["valid"])
                if(data["ns2"]["valid"] != "true"){
                     $ns2.css("color","red")
                }
            }
        	$ns1.show()
    		$ns2.show()
    		$("button#check_dns").removeAttr("disabled");
        },
    });
}

*/


var statusTable1=[];
var statusTable2=[];
var statusTable=[];
	
function fetchISDNstatus(){
	$.ajax({		//get tracing properties
		type: "GET",
		async:true,
		url: "cgi-bin/getIsdnStatus.lua",
		contentType: "application/json; charset=utf-8",
		dataType: "json",
		success: function (data) {
			//console.log(data["status1"])
			$("#routingTableTree").find("#chainOut").append('<li id="isdnStatus2" class="leave"></li>');
			$("#routingTableTree").find("#chainIn").append('<li id="isdnStatus2" class="leave"></li>');
			formatISDNstatus(data)
			
		},
		error: function(){
			$("#isdnStatus1").text("incomplete results, please refresh!");
			$("#isdnStatus2").text("incomplete results, please refresh!");
			//$this.html('<div class="ui-state-error>Failed to load Ressources!</div>"')
		}
	});
}
	
		
	// when DSS1 = receive
	//L* -> sent
function isdnHtmlTable(status){
	
	statusTable=[];
	statusTable.push('<table class="isdnTable">')
	statusTable.push('	<th>Start time</th>	\
								<th><center>Direction</center> </th><th><center>CallRef</center></th><th><center>CallRef Len</center></th> \
								<th><center>Event</center></th>	\
							')
	if(status.events && status){							
		$.each(status.events,function(i,event){		//event is a stupid and missleading keyword!!! sry 4 that its just a 'var' here!
			if(!event.empty){
				
				var direction;
				if(event.event.search(/DSS1/) != -1){
					direction="Receive";
				}else{
					direction="Sent";
				}
			
				statusTable.push('<tr><td class="time">'+event.time+"</td>")
				statusTable.push('<td class="direction">'+direction+"</td>")
				statusTable.push('<td class="callRef">'+event.callref+"</td>")
				statusTable.push('<td class="callReflen">'+event.callreflen+"</td>")
				statusTable.push('<td class="event">'+event.event.replace('DSS1_','').replace('L4L3_','')+"</td>")
	
				
				$.each(event.infos.sort().reverse(),function(k,info){
					
					if(!info.empty){
						statusTable.push('<tr><td>&nbsp;</td><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td><td class="inf">');
						var keys = [];
						$.each(info,function(k,item){
							if(k != "time" && k != "instance"){
								keys.push(k +"="+item)
							}
						})
						keys.sort();
						
						$.each(keys,function(a,b){
							statusTable.push(b);
							if(a < keys.length-1){
								statusTable.push(",&nbsp;&nbsp;&nbsp;")
							}
						});
						statusTable.push('</td>')
					}
				})
				
				
				statusTable.push('</tr>');	
			}
		});
	}
	statusTable.push('</table>');
	return statusTable;
}

function formatISDNstatus(data){
	$setupTable=$("table#setupTable")

	statusTable1=[];
	statusTable2=[];
	statusTable=[];
	
	
	status1=data["status1"][0]
	status2=data["status2"][0]
	
	
	if(status1){
		isdnHtmlTable(status1,statusTable1)
		$("ul#outbound").find("ul#chainOut li#isdnStatus2").html('<a id="status1chain" href="#">chained route: ' +  data["status1"][0].time + '</a>')
	}else{
		$("ul#outbound").find("ul#chainOut li#isdnStatus2").html('<a href="#">none</a>')
	}
	
	if(status2){
		isdnHtmlTable(status2,statusTable2)
		$("ul#inbound").find("ul#chainOut li#isdnStatus2").html('<a id="status2chain" href="#">chained route: ' +  data["status2"][0].time + '</a>')
	}else{
		$("ul#inbound").find("ul#chainOut li#isdnStatus2").html('<a href="#">none</a>')
	}
	
		
}














function listRoutingTables(){
	
	
	
	
	
	numRand = Math.floor(Math.random()*1101);
	var months = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
	
	$.ajax({
		async: false,		//do it now, and wait
		url: "/cgi-bin/webData2.lua?command=routingTable&rand="+numRand,
		cache: false,
		dataType: "json",		
		success: function(data) {
			outbound=data.command.outbound;
			inbound=data.command.inbound;
			
			
			$.each(outbound,function(i,chan){
				if(typeof(chan) == "object"){
					var date=new Date(chan.change*1000);
					var myDate=months[date.getMonth()]+"-"+date.getDate()+"-"+date.getFullYear()+"  "+date.getHours()+":"+date.getMinutes()+":"+date.getSeconds();
					var file=chan.file;
					chan=chan.file.replace("outbound_call_","").replace(".log","")
					
					$("ul#outbound").find("ul#routeOut").append('<li class="leave" id="'+file+'"><a href="#">'+myDate+' D-Channel: '+chan+'</a></li>')
				}else{
					$("ul#outbound").find("ul#routeOut").append('<li>Out Not Routed <yet </li>')
				}
			})
			$.each(inbound,function(i,chan){
				if(typeof(chan) == "object"){
					var date=new Date(chan.change*1000);
					var myDate=months[date.getMonth()]+"-"+date.getDate()+"-"+date.getFullYear()+"  "+date.getHours()+":"+date.getMinutes()+":"+date.getSeconds();
					var file=chan.file;
					chan=chan.file.replace("inbound_call_","").replace(".log","")
					$("ul#inbound").find("ul#routeIn").append('<li class="leave" id="'+file+'"><a href="#">'+myDate+' D-Channel: '+chan+'</a></li>')
				}else{
					$("ul#inbound").find("ul#routeIn").append('<li>Out Not Routed <yet </li>')
				}
			});
			
			
		}
	});
	
	fetchISDNstatus();
}


function tracer2(method, command,lines) {
	 numRand = Math.floor(Math.random()*1101);
	  if (pageData.ajaxStatus) {$("#error").append("#####!!!!!!!!!!!### ajax call in progress");	return false	}
	  pageData.ajaxStatus=true;		//set ajax Progress=true
	 var  customfilter=$("div#traceDialog").find("input#customfilter").val();
	  if(customfilter.length==0){
		  customfilter="nil";
	  }
	  
		$.ajax({
			url : "/cgi-bin/webData2.lua",
			processData : true,
			cache: false,
			data : {
				method:method,
				command:command,
				lines:$("div#traceDialog").find("select#trace_lines").val(),
				rand:numRand,
				filter:$("div#traceDialog").find("input#syslogfilter").is(":checked"),
				l2xfilter:$("div#traceDialog").find("input#l2xfilter").is(":checked"),
				
				SIPMSGfilter:$("div#traceDialog").find("input#SIPMSGfilter").is(":checked"),
				SIPMSGfilter:$("table#filterTable").find("input#SIPMSGfilter").is(":checked"),
				SIPCMDfilter:$("table#filterTable").find("input#SIPCMDfilter").is(":checked"),
				ISDNCMDfilter:$("table#filterTable").find("input#ISDNCMDfilter").is(":checked"),
				ISDNMSGfilter:$("table#filterTable").find("input#ISDNMSGfilter").is(":checked"),
				JOBCMDfilter:$("table#filterTable").find("input#JOBCMDfilter").is(":checked"),
				customfilter:customfilter
			},
			dataType : "json",
			success : function(data) {
				_string="";
				$.each(data.stdout, function(i, data) {
					_string=_string+data+"\n";
				});
				
				
				if(command == "capture"){
					$("#trace_output").html("<h3>Filtered version of Tcpdump. For details download and analyze</h3><pre>"+_string+"</pre>");	
				}else{
					$("#trace_output").html("<pre>"+_string+"</pre>");
				}
				
				
				
				highLightElements=$("#trace_output").find("pre");
				
				var customWords=[]
				customWords.push(customfilter)
				markBadWords(highLightElements,"goodWord",customWords);
				
				markBadWords(highLightElements,"badWord",pageData.badWords);
				markBadWords(highLightElements,"goodWord",pageData.goodWords);
				markBadWords(highLightElements,"importantWord",pageData.importantWords);
				
				
				var _words=$("div#traceDialog").find("input#highLightSomeThing").val()
				var _someWords=[];
				$.each(_words.split(","), function(i,val){
					_someWords[i]=val;
				});
				markBadWords(highLightElements,"importantWord",_someWords);
				
				
				if($("div#traceDialog").find("input#followTail").is(":checked") === true){
					$("#trace_output").parent().animate({scrollTop: $("#trace_output").height()}, 1100);
				}
			},
			complete:function(){
				pageData.ajaxStatus=false;	//set ajax Progress=true
			}
		});
	}

function markBadWords(target,type,words){
	//target must be something like $("foo").find("pre");
	//maybe find gives just one element here
	//$.each(words.split(","), function(i,val){
		//target.highlight(val);
			$(target).highlight(words, { wordsOnly: false, element: 'span', className: type });
}


$.fn.serializeObject = function()
{
    var o = {};
    var a = this.serializeArray();
    $.each(a, function() {
        if (o[this.name] !== undefined) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });
    return o;
};

function benchmark() {
	var it = 1;
	var start = new Date().getTime();
	for (i = 0; i < it; ++i) {
		// document.createElement('div');
	}
	var end = new Date().getTime();
	if (it > 5) {
		alert(end - start + "MS");
	}
}
function getRoutingTable(mode,calledPartyNumber,selector){
	
	//mode is in|out
	numRand = Math.floor(Math.random()*1101);
	$.ajax({
		url: "/cgi-bin/testCalls.lua",
		processData:true,
		cache: false,
		data: {
			mode:mode,
			calledPartyNumber:calledPartyNumber,
			rand:numRand
			
			},
		dataType: "json",
		success: function(data) {
			
			element = $(document.createElement('div'));
			$.each(data,function(i,data){
				if(data.indexOf("found")!=-1){
					element.append('<pre class="stdout" style="color:green"><b>'+data+'</b></pre>');	
				}
				else{
					element.append('<pre class="stdout">'+data+'</pre>');
				}
			
			});
			$(selector).empty();
			$(selector).html(element);
			
			if(data.length == 0){
				element.append('<pre class="stdout"><b>No Routing found for this Number</b></pre>')
			}
		},
		error : function(x, y, z) {
			$(selector).html("Nothing yet");
			}
	});
}



function getTestCallLog(file,selector){
	numRand = Math.floor(Math.random()*1101);
	$.ajax({
		url: "/cgi-bin/testCalls.lua",
		processData:true,
		cache: false,
		data: {
			getLog:true,
			file:file,
			rand:numRand
			},
		dataType: "json",
		success: function(data) {
			element = $(document.createElement('div'));
			_stdout="";
			$.each(data,function(i,data){
				//element.append('<pre class="stdout">'+data+'</pre>');
				_stdout=_stdout+data+"\n";
				
			});
			if(data.length==0){
				//element.append('<pre class="stdout"><b>No tracked Test Calls yet</b></pre>')
				_stdout='<pre class="stdout"><b>No tracked Test Calls yet</b></pre>'
			}
			
			$(selector).empty();
			$(selector).html('<pre>'+_stdout+'</pre>');
			
				highLightElements=$(selector).find("pre");
			    //alert(highLightElements.length)
				markBadWords(highLightElements,"badWord",pageData.badWords);
				markBadWords(highLightElements,"goodWord",pageData.goodWords);
				markBadWords(highLightElements,"importantWord",pageData.importantWords);
				
		},
			error : function(x, y, z) {
				$(selector).html("Nothing yet" + x +y +z);
			}
	});
}




/*
 *Buttons
 * 
 */
$('button[id=test_subGroup]').live('click', function() {
	category=$(this).attr("category");
	subCategory=$(this).attr("subCategory");
	$.getJSON("cgi-bin/execute-system.lua",{action: "test_subGroup", category:category, subCategory:subCategory}, function(data) {
		
	});
	
});



$('button[id=cleanup]').live('click', function() {
	action="cleanup";
	$.getJSON("cgi-bin/execute-system.lua",{ name: name, action: action}, function(data) {
		location.reload();
	});
});




$('button[id=action]').live('click', function() {
	
	if($("#logDialog").dialog("isOpen")){
		$("#logDialog").dialog("close");
	}
	name=$(this).attr("name");
	id=name.replace(/\./g,"_");
	action=$(this).text();
	category=$(this).attr("category");
	subCategory=$(this).attr("subCategory");
	
	$.getJSON("cgi-bin/execute-system.lua",{ name: name, action: action}, function(data) {
		//alert("excuted action:" + action);
		update(category,subCategory,name);
	});
});




$('button[id=log]').live('click', function() {
	clearInterval(logTimer);
	name=$(this).attr("name");
	action=$(this).text();
	category=$(this).attr("category");
	subCategory=$(this).attr("subCategory");
	
	
	$("#logDialog").dialog("open");
	
	$("#logDialog" ).dialog({ title: 'Test log of: ' +name });
	$(".logContent").empty();
	
	loadLog(name,null,category,subCategory);
	var logTimer = setInterval(function(){
		loadLog(name,logTimer);
		$("#logTimer").html("<div>"+logTimer+"</div>");
	},2000);
});




$('button[id=refresh]').live('click', function() {
	if($("#logDialog").dialog("isOpen")){
		$("#logDialog").dialog("close");
	}
	
	name=$(this).attr("name");
	category=$(this).attr("category");
	subCategory=$(this).attr("subCategory");
	action=$(this).text();
	
	update(category,subCategory,name);
	colorize();
});




//service rsyslog restart
$.extend({
	  getUrlVars: function(){
	    var vars = [], hash;
	    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
	    for(var i = 0; i < hashes.length; i++)
	    {
	      hash = hashes[i].split('=');
	      vars.push(hash[0]);
	      vars[hash[0]] = hash[1];
	    }
	    return vars;
	  },
	  getUrlVar: function(name){
	    return $.getUrlVars()[name];
	  }
	});	