#!/usr/bin/luaweb
dofile('cgi.inc')
require('json')

print ("Content-type: application/json\n")
--[[
nameserver1 and nameserver2 are stored in ENV variables IP_DNS1 and IP_DNS2
this script tries to lookup the nameserver's IP with the currently set nameserver

I wanted to test for google's IP - but we might not be online!
this script runs very long if nameserver settings are wrong!

if we cannot resolv the IP with current nameserver - something is invalid

--]]

local table={}

table["ns1"]={}
table["ns2"]={}

nameserver1=os.captureN("[ -e /tmp/cmdline ] && cat /tmp/cmdline | grep IP_DNS1 | awk -F \"=\" '{print $2}'" )
nameserver2=os.captureN("[ -e /tmp/cmdline ] && cat /tmp/cmdline | grep IP_DNS2 | awk -F \"=\" '{print $2}'" )



if(nameserver1 == "")then
	resolvconf=stdout2table("[ -e /etc/resolv.conf ] && cat /etc/resolv.conf | grep ^nameserver")
	if(resolvconf[1] ~= nil)then
		nameserver1=Split(resolvconf[1]," ")[2]
	end
end
if(nameserver2 == "")then
	resolvconf=stdout2table("[ -e /etc/resolv.conf ] && cat /etc/resolv.conf | grep ^nameserver")
	if(resolvconf[2] ~= nil)then
		nameserver2=Split(resolvconf[1]," ")[2]
	end
end

if(nameserver1 == "")then
	table["ns1"]["status"]="Nameserver1 not defined"
	table["ns1"]["valid"]=os.captureN("LC_ALL=C /usr/bin/nslookup -q=any localhost | grep -q ^Address: && echo true || echo false")
	--just try to resolv
	table["ns1"]["address"]="none"
	else
	table["ns1"]["status"]="Nameserver1 is defined"
	table["ns1"]["address"]=nameserver1
	table["ns1"]["valid"]=os.captureN("LC_ALL=C /usr/bin/nslookup -q=any "..nameserver1.." "..nameserver1.."  | grep -q ^Address: && echo true || echo false")
end
if(nameserver2 == "")then
	table["ns2"]["status"]="Nameserver2 not defined"
	table["ns2"]["valid"]=os.captureN("LC_ALL=C /usr/bin/nslookup -q=any localhost | grep -q ^Address: && echo true || echo false")
	table["ns2"]["address"]="none"
	else
	table["ns2"]["status"]="Nameserver2 is defined"
	table["ns2"]["address"]=nameserver2
	table["ns2"]["valid"]=os.captureN("LC_ALL=C /usr/bin/nslookup -q=any "..nameserver2.." "..nameserver2.." | grep -q ^Address: && echo true || echo false")
end


print(json.encode(table))
