#!/usr/bin/luaweb

require("json")
require("socket")
dofile("cgi.inc")

print ("Content-type: application/json\n")

local port=3218
local response={}

local host=request_param("host") or "10.2.2.104"

c = socket.connect(host, port)
if(c == nil)then
	response[1]="Connection to "..host.." on port "..port.." refused"
	print(json.encode(response))
	os.exit(1)
end


--[[
	:channel_state --channel_name="1.b/B24/S2M/2xG704IDT_E1" --status="49332845583123 --> 7777" --called_party_number="7777" --calling_party_number1="49332845583123" --calling_party_number2="" --redirected_party_number="" --destination="fms" --used
	:dchannel --message="alerting" --dchannel="jobcontrol_isdn:30" --channel_id=30 --calling_party_number="49332845583123" --calling_party_number2="" --called_party_number="7777" --redirecting_number=""
]]--


while true do
	line,err,rest = c:receive("*l")
	if(line ~= nil and string.find(line,'-message="alerting"')) then 
		local params=Split(line,"%-%-")
		local channel_id
		for k,v in pairs(params)do
		    if(string.find(v,"channel_id") ~= nil)then
		        channel_id=(Split(v,"=")[2])
		    end
		end
		if(channel_id ~= nil)then
			print("alerted on channel:"..channel_id)
			local msg=':receive --client_id=0815 --command=accept --bchan_exec="/usr/fb/bin/fax.prc" --bchan_param=" --type=recv --rx-file="/tmp/rec.bff" --csid="+49 (3328) 455321" --debug-snfs=0 --debug-fc=0 --debug-t30=1 --debug-t4=0 --debug-lapi=0 --debug-modem=0 --stat-fd=1" --channel_id='..channel_id
			c:send(msg.."\r\n")
		end
		

	end
	if(err ~= nil)then 
		print("error: "..err)
		break 
	end
end

c:close()

print(json.encode(response))
