#!/usr/bin/luaweb
dofile('cgi.inc')
require('json')
function trim6(s)
  return s:match'^()%s*$' and '' or s:match'^%s*(.*%S)'
end
function getSockets(netstat) 
  local sockets={}
  for key,value in pairs(netstat) do
	value=string.sub(value, 21, 44)
	value=string.gsub(value,".*:","")
	value=string.gsub(value,".*:","")
	sockets[key]=trim6(value)
 end
 return sockets
end
function isProcess(psfax,process)
  for key,value in pairs(psfax) do
	value=string.sub(value, 28, -1)
	if(string.match(value, process)~=nil)then
	   return "ok"
	end
 end
 return "failed"
end
function isPort(sockets,port)
  if (sockets[port] ~= nil)then
    return "ok"
  end
 return "false" 
end

function check_snfsserver(psfax,sockets)
  test={}
  i=1
  ports={12,6,7,8}
  process="snfsserver"
  process="lua"
  
  test[i]="checking snfsprocess..."..process.." "..isProcess(psfax,process)
  i=i+1

  for n,port in pairs(ports)do
    test[i]="checking port: "..port.."... "..isPort(sockets,port)
    i=i+1
  end
  return stdout
end


psfax=stdout2table('LC_ALL=C /bin/ps fax')
netstat=stdout2table('export LC_ALL=C && /bin/netstat -anp | egrep -v "^unix|^tcp6|^udp6|^[A-Z]" ' )

sockets=getSockets(netstat)

snfsserver=check_snfsserver(psfax,sockets)
print(json.encode(snfsserver))



function soll()
  test={}
  test["name"]="name"
  test["type"]="port"
  test["description"]="description: schalala"
  test["result"]="OK"
  test["stdout"]="checking port: 1234 ... ok"
end



