var cache = { // performance?! define abosulte item height with cgi, no heighht calc at all
	items : 0,
	offsetMax : 11,
	displayChunkSize : 1, // insert at once form cache to visible
	itemsHeight : 0,
	displayMin : 10,
	displayMax : 10,

	cacheDirection:"down",
	cacheMin : 15,
	cacheMax : 15,
	displaying : 0,
	chunkSize : 2, // how many items to fetch at once
	totalHeight : 1,
	first : 0, // first item id in cash
	last : 0, // last
	count : 0, // items received via ajaxx
	visible : 0,
	direction : "down",
	container : ".cache",

	getStatus : (function getStatus() {
		$chunks = $(".cache").children();
		cache.items = $chunks.children().length; // # count of meineItems
		cache.offset = (cache.cacheMin - cache.items); // mindest#Items - meine#Items =X items left to cache

		cache.first=$(".inbox").find(".chunk").first().children().attr("id");		// here we got to handle IDs ..bah!
		cache.last=$(".cache").find(".chunk").last().children().attr("id") || 0;
			
		tmp = 0;
		$.each($(".cache").children(), function() {
			tmp = tmp + $(this).height();
		});
		this.totalHeight = tmp;
		console.log("cache offset:"+ this.offset + "> maxOffset " + this.offsetMax)
		if (this.offset > this.offsetMax) {
			cache.fillCache();
		}
	}),

	fillCache : (function fillCache() {
		$("#error").append("triggering database for " + this.offset+ " more elements<br/>")
		var myData = {}
		if (cache.ajaxStatus) {$("#error").append("#####!!!!!!!!!!!### ajax call in progress");	return false} // abort if still getting

		console.log("last: "+ this.last + "\n first: "+ this.first)
		
		cache.ajaxStatus = true; // invalidate cache
		$.ajax({
			async : false,
			url : "/cgi-bin/webFax/getData.lua",
			data : {
				lastItem : this.last,
				direction : this.direction,
				firstItem : this.first,
				count : this.offset
			},
			dataType : "json",
			success : function(data) {
				if (data) {
				} else {
					cache.ajaxStatus = false;
					return true
				}
				// chunkElements=document.createElement("div");
				chunks = $("<div class='chunks'></div>");

				var htmlBuffer = [];
				
				//foo=data.items;
				
				data.items.sort(function(a, b) {
				   var compA = a.id;
				   var compB = b.id;
			  	   return compA>compB
				})
				
				$.each(data.items, function(i, item) {
					//console.log(item.id)
					htmlBuffer.push("<div class='chunk'>" + item.html + "</div>");// theme!
					//console.log(item.html)
				});		
				chunks.append(htmlBuffer.join("")); // append to an element
				
				cache.items += chunks.find(".listItem").length; // set the counters
				cache.last += chunks.find(".listItem").length; // set the counters

				
				if(cache.direction=="down"){
					$(".cache div.chunks").append(chunks.children());
				}else{
					alert("prepended" + chunks.children().length)
					$(".cache div.chunks").prepend(chunks.children());
					
				}
			},
			complete : function() {
				cache.ajaxStatus = false;
				cache.updatePane();
			},
			error : function(XMLHttpRequest, textStatus, errorThrown) {
				$("#error").append(textStatus, errorThrown);
				cache.ajaxStatus = false;
			}
		});
	}),

	dynaScrollContainer : function(direction) {
		if (this.displaying < this.displayMin) {
			this.updatePane();
		}
		cache.updatePane(direction);
	},

	updatePane : (function(direction) {
		if (direction == "down") {
			$myChunks = $(".cache").find(".chunk:lt(" + this.displayChunkSize + ")")
			chunkHeight = $myChunks.children().last().height(); // /Do something  with me!
			// cache.displayChunkSize*chunkHeight

			viewTop = $(".inbox").scrollTop();
			// $( ".inbox" ).scrollTop( viewTop + (chunkHeight*this.displayChunkSize));
			newScrollPos = (viewTop + (chunkHeight * this.displayChunkSize))
			if (!(this.displaying < this.displayMax)) { // remove alte items,
				$(".inbox").find(".chunk:lt(" + this.displayChunkSize + ")").remove();
			}

			$(".inbox").append($myChunks).children(); // append new items to visible container seems to remove from dom
			cache.items = cache.items - this.displayChunkSize; // count down, as they were removed
			cache.displaying = $(".inbox").children().length; // noch mal  nachzaehlen ...vllt. gibts ne elegantere zaehlmethode? ..aber so sind wir immer korrekt

			cache.getStatus();
			cache.displaying = $(".inbox").children().length // set the
			// number of currently displayd chunks

		}
		if (direction == "up") { // this is only triggerd, if: viewTop < 200
			
			//console.log(cache.first)
			
			$(".inbox").prepend($(".cache").find(".chunk").last());
			$(".inbox").find(".chunk").last().remove();
			
			if (cache.displaying > cache.displayMax) {
				// $(".inbox").find(".chunk:lt(1)").remove();
			}
		cache.getStatus();
		}
	})

}
