

var dynaScroll={
		cacheSize:0,	//cache starts with 0 items
		cacheMin: 3,	//get a new chunk (with X items)
		displayItems: 5,	//visible container items
		chunkSize:14,	//get n items from the server
		
			getMoreCacheItems: function getMoreCacheItems(targetArea,item){
				//$("#error").append("triggering database for " + this.offset+ " more elements<br/>")
				var myData = {}
				if (dynaScroll.ajaxStatus) {$("#error").append("#####!!!!!!!!!!!### ajax call in progress");	return false} // abort if still getting
				dynaScroll.ajaxStatus = true; // invalidate cache
				
				if(item <= 0 && targetArea=="up"){dynaScroll.ajaxStatus = false; return true}	//don't trouble the server if there can't be items
				
				$.ajax({
					async : false,
					url : "/cgi-bin/webFax/getData2.lua",
					data : {
						direction : targetArea,
						item: item,
						count : dynaScroll.chunkSize
					},
					dataType : "json",
					success : function(data) {
						if(data.rows > 0 ){				//don't get stuck on empty data!
							if(targetArea=="up"){
								data.items.sort(function(a, b) {
									var compA = a.id;
									var compB = b.id;
						  	   		return compA>compB
								})
							}
								
							//chunks = document.createElement("div");
							//chunks.className("chunks");
							chunks = $("<div class='chunks'></div>");
							htmlBuffer=[];
							$.each(data.items, function(i, item) {
								htmlBuffer.push("<div class='chunk'>" + item.html + "</div>");// theme!
							});
							
							dynaScroll.cacheSize=(parseInt(dynaScroll.cacheSize)+parseInt(htmlBuffer.length))
							//console.log("now:" + dynaScroll.cacheSize)
							
							chunks.append(htmlBuffer.join("")); // append to an element
							
							if(targetArea=="down"){
								$(".cache div.chunks").append(chunks.children());
							}else{
								$(".cache div.chunks").prepend(chunks.children());
							}
								
						}else{				//don't get stuck on empty data!
							dynaScroll.ajaxStatus = false;	
						}	
						
					},
					complete : function() {
						dynaScroll.ajaxStatus = false;
						//dynaScroll.updatePane();
					},
					error : function(XMLHttpRequest, textStatus, errorThrown) {
						$("#error").append(textStatus, errorThrown);
						//dynaScroll.ajaxStatus = false;
					}
					
				});
		},

		moreItemsNeeded: function moreItemsNeeded(targetArea,dirChanged){				//dirChanged is true, if scrolling changed direction and is at upper|lower limit
			//cacheSize=$(".cache").find(".chunk").length;
			if(dynaScroll.cacheSize <= this.cacheMin){
				if(targetArea=="up"){
					if(dirChanged==true){												//cache will be empty here! so lets use last inbox's item as reference
						//$("#error").append("CACHING OUT!!");
						item=$(".inbox").find(".chunk").first().children().attr("id")|| 0;
					}else{
						item=$(".cache").find(".chunk").first().children().attr("id")|| 0;		//else use cache's last item as ref
					}
					dynaScroll.getMoreCacheItems(targetArea,item);								//get some Elements
				}
				
				
				if(targetArea=="down"){
					if(dirChanged==true){
						//$("#error").append("CACHING OUT!!");
						item=$(".inbox").find(".chunk").last().children().attr("id")|| 0;
					}else{
						item=$(".cache").find(".chunk").last().children().attr("id")|| 0;	
					}
					dynaScroll.getMoreCacheItems(targetArea,item);
				}
			}
			
		},
		
			
		
		applyItems: function applyItems(targetArea){
			if(targetArea != dynaScroll.lastDirection){		
				// delete the cache if direction changed from lower to upper limit or vice versa
				$(".cache").find(".chunk").remove();
				dynaScroll.cacheSize=0;
				dynaScroll.moreItemsNeeded(targetArea,true);
			}
				
			
			if(targetArea=="up"){
				$(".inbox").prepend($(".cache").find(".chunk").last());
				dynaScroll.cacheSize=dynaScroll.cacheSize-1;
				inboxLength=$(".inbox").find(".chunk").length;
				
				if(inboxLength > dynaScroll.displayItems){
						$(".inbox").find(".chunk").last().remove();
				}
			}
		
			if(targetArea=="down"){
				$(".inbox").append($(".cache").find(".chunk").first());
				dynaScroll.cacheSize=dynaScroll.cacheSize-1;
				inboxLength=$(".inbox").find(".chunk").length;
				
				if(inboxLength > dynaScroll.displayItems){
						$(".inbox").find(".chunk").first().remove();
				}
			}
			
			
			
			dynaScroll.moreItemsNeeded(targetArea);
		}
}