#!/usr/bin/luaweb

dataDir = os.getenv("DATA_DIR") or "/data"
dofile(dataDir .. "/config.lua")

description="check validity, corresponding system processes and system ports"


-- correct some config Settings
--[[
if(config.struct_Box.struct_DChannel[1]==nil)then
    local t = {}
    t = config.struct_Box.struct_DChannel
    config.struct_Box.struct_DChannel = nil
    config.struct_Box.struct_DChannel = {}
    config.struct_Box.struct_DChannel[1]=t
end
]]--
dchannelCount=table.getn(config.struct_Box.struct_DChannel)
print (dchannelCount.." D-Channels found" )


--check callp ports from 3217 iterating pro D-Channel!!!!!!




for k,v in ipairs(config.struct_Box.struct_DChannel) do
	--looping over Dchannels
	print("Slot: "..v.string_IlidSlot)
	print("Index: "..v.string_IlidIndex)
	print("Valid: "..tostring(v.bool_CfgValid))
	print("Proto: "..v.struct_GateParams.string_SipProtocol)

	cmd='/bin/ps fax | grep isdn.prc | grep "\\-\\-slot='..v.string_IlidSlot..'" | grep "\\-\\-slot-index='..v.string_IlidIndex..'" 2>&1 >/dev/null'
	retval=os.execute(cmd)
	if(retval~=0) then 
		print("error!") 
		os.exit()
	end
	

	table=v.struct_GateParams["struct_CallProcTable"]
	print(table)

	if(table ~= nil) then
		for k1,v1 in ipairs(table) do
	--		print (v1.string_Description)
		end
	end
	print("#################")
end




for i=1,dchannelCount,1 do
	print("loooking up port: "..3216+i)
	cmd="netstat -anp | grep "..3216+i
	if(os.execute(cmd)~=0) then
		print("port is missing")
		os.exit()
	end
end


