function trim6(s)
  return s:match'^()%s*$' and '' or s:match'^%s*(.*%S)'
end

function stdout2table(cmd)
    local myTable={}
    local i=1
    stdout=os.capture(cmd,true)
    for line in stdout:gmatch("[^\r\n]+")do
        myTable[i]=line
        i=i+1
    end
    return myTable
end

function os.capture(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
      s = string.gsub(s, '^%s+', '')
      s = string.gsub(s, '%s+$', '')
      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

function request_param(name)
        query=os.getenv("QUERY_STRING")
        if(query) then
                for param in string.gmatch(query,"[^&]+") do
                        if(string.match(param,'^'..name..'='))then
                                value=string.gsub(param, name..'=', "")
                                return value
                        end
                end
        end
end

